<script setup lang="ts">
import { onMounted, ref } from 'vue';

const game_state = ref({players:[{name:"", points:0}], end_time: 0});
const WEBSOCKET_URL = "ws://127.0.0.1:3030/socket";
const timer_text = ref("Loading...");

onMounted(() => {
  let ws = new WebSocket(WEBSOCKET_URL);


  ws.addEventListener("message", (event) => {
    console.log(event)


    let parseable = event.data.split(/:(.*)/s)
  

    switch (parseable[0]) {
      case "state":
        let buffer = JSON.parse(parseable[1]);

        buffer.players = (buffer.players as Array<any>).sort((a, b) => 
          a.points > b.points ? -1 : 1
        )

        game_state.value = buffer;
     }
  })

  setInterval(() => {
    let now = Date.now();

    let millis_remaining = game_state.value.end_time * 1000 - now;

    if (millis_remaining < 0) millis_remaining = 0;


    console.log(game_state.value.end_time * 1000);
    console.log(now);

    let hours = ~~(millis_remaining / (3600 * 1000));
    let minutes = ~~((millis_remaining - (hours * (3600 * 1000))) / (60*1000));
    let seconds = millis_remaining % (60 * 1000);
    
    
    timer_text.value = `${hours}:${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0').slice(0,2)}`;

  }, 1000)


  ws.addEventListener("open", () => {
    ws.send("get_state");
  })
})

// ws.send("get_state");
</script>

<template>
  <div class="absolute top-0 right-0 w-64 flex flex-col text-[#afadae] text-2xl from-[#2e2d28] via-50% via-[#2e2d28dd] to-transparent bg-gradient-to-l gap-1">
    <hr class="from-[#2e2d28] bg-gradient-to-l border-2 mb-2"/>
    <div class="self-end text-shadow-custom flex flex-col pr-2">
      <span class="self-end text-4xl bold">{{ timer_text }}</span>
      <span class="self-end text-sm uppercase tracking-wide bold opacity-50">Fin de la partie a 00:00</span>
    </div>
    <hr class="from-[#2e2d28] bg-gradient-to-l h-1 border-2 mt-2 mb-2"/>
    <transition-group name="slide">
      <div class="flex justify-end align-center " v-for="player in game_state.players" :key="player.name">
        <span class="text-shadow-custom text-2xl capitalize">{{player.name}}</span>
        <span class="text-shadow-custom w-16 text-right mr-2">{{player.points}}</span>
      </div>
    </transition-group>
    <hr class="from-[#2e2d28] bg-gradient-to-l border-2 mt-2"/>
  </div>
</template>

<style scoped>

* {
  font-family: "garamond-premier-pro";
}

.text-shadow-custom {
  text-shadow: 4px 2px 4px rgba(0,0,0,0.8); 
}


hr {
    background-image: linear-gradient(-90deg, #afadae, transparent);
    
    border: 0;
    height: 1px;
}

.slide-move {
  transition: transform 0.5s cubic-bezier(0,.96,.74,1.01);
}


</style>
